/'
   Screen2AVI Example
   by Vincent DeCampo, (c)2009

   version 0.9

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
'/

#Include "file.bi"
#Include "screen2avi.bi"

#Define FPS  10
#Define SCRW 640
#Define SCRH 480

Screenres SCRW,SCRH,32

Dim Movie As _Screen2AVI = _Screen2AVI("MyAVI.avi",FPS)
Dim As Double ftimer 

   'We can pre-save codec info and load it
   If FileExists("movie.cfg") Then
      Movie.LoadCompressionFile("movie.cfg")
   Else
      If Movie.GetCompressionSettings() Then
         Movie.SaveCompressionFile("movie.cfg") '<-Save settings and we can
                                                 '  load them later without
                                                 '  opening up codec window
      Else
         End
      End If
   EndIf
   
   WindowTitle "Writing Screen to AVI!"
   
   Movie.AVIStart()
   
   Do
      ScreenLock
         Line (Rnd*SCRW,Rnd*SCRH)-(Rnd*SCRW,Rnd*SCRH),Rnd*&hFFFFFF
         Draw String (5,5),"Press ESC to STOP!"
      ScreenUnLock
            
      'Only Add frames at FPS times per sec
      If (Timer-ftimer) > (1/FPS) Then
         ftimer=Timer
         Movie.AddFrame()
      EndIf                     
   
      Sleep 3
   
   Loop Until InKey=Chr(27)
   
   Movie.AVIStop()