/'
   Screen2AVI Object
   by Vincent DeCampo, (c)2009

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

'/

#Include Once "win/vfw.bi"
#Include Once "crt.bi"

Function LoadCompressionOptions(Filename As String) As AVICOMPRESSOPTIONS Ptr 
Dim As AVICOMPRESSOPTIONS Ptr opts
Dim As Byte Ptr lpData1,lpData2
Dim As Integer hFile = FreeFile

   opts = New AVICOMPRESSOPTIONS

   Open filename For Binary As hFile
      
      Get #hFile,,*opts

      If opts->cbFormat Then
         lpData1        = Allocate(opts->cbFormat)
         opts->lpFormat = Allocate(opts->cbFormat)
         Get #hfile,,*lpData1,opts->cbFormat
         memcpy opts->lpFormat,lpData1,opts->cbFormat
      EndIf
         
      If opts->cbParms Then
         lpData2       = Allocate(opts->cbParms)
         opts->lpParms = Allocate(opts->cbParms)
         Get #hfile,,*lpData2,opts->cbParms
         memcpy opts->lpParms,lpData2,opts->cbParms
      EndIf

   Close hFile
   
   DeAllocate lpData1
   DeAllocate lpData2
   
   Return opts
      
End Function 

Function SaveCompressionOptions(filename As String, opts As AVICOMPRESSOPTIONS Ptr) As Integer
Dim As Integer hFile = FreeFile
Dim As Byte Ptr lpData1,lpData2

   If opts->cbFormat Then
      lpData1 = Allocate(opts->cbFormat)
      memcpy lpData1,opts->lpFormat,opts->cbFormat
   EndIf
   
   If opts->lpParms Then
      lpData2 = Allocate(opts->cbParms)
      memcpy lpData2,opts->lpParms,opts->cbParms      
   EndIf

   Open filename For Binary As hFile
      Put #hFile,,*opts
      If opts->cbFormat Then
         Put #hfile,,*lpData1,opts->cbFormat
      EndIf 
      If opts->cbParms Then
         Put #hFile,,*lpData2,opts->cbParms
      EndIf
   Close hFile

   DeAllocate lpData1
   DeAllocate lpData2
      
   Return 1
   
End Function

Function CreateNewAVI (Filename As LPCSTR) As PAVIFILE 
Dim As PAVIFILE         pf 
Dim As HRESULT          hr 
   
   AVIFileInit()
         
   'Create new AVI file using AVIFileOpen
   hr = AVIFileOpen(@pf, Filename, OF_WRITE Or OF_CREATE, NULL)
   
   Return pf 
   
End Function

Function CreateVideoStream (pf As PAVIFILE, strhdr As AVISTREAMINFO, bi As BITMAPINFOHEADER) As PAVISTREAM 
Dim As PAVISTREAM ps   
Dim As HRESULT    hr 

   With bi
      .biSizeImage = (((.biBitCount*.biWidth + 31) And &HFFE0) Shr 3) * .biHeight
   End With
   SetRect(@strhdr.rcFrame, 0, 0, bi.biWidth, bi.biHeight) 
 
   'Create a stream using AVIFileCreateStream 
   hr = AVIFileCreateStream(pf, @ps, @strhdr)
   If hr <> 0 Then            
      AVIFileRelease(pf) 
      Return 0
   End If
   
   Return ps
   
End Function 

Function CreateCompressedVideoStream(ps As PAVISTREAM,opts As AVICOMPRESSOPTIONS,bi As BITMAPINFOHEADER) As PAVISTREAM 
Dim As PAVISTREAM psCompressed
Dim As HRESULT    hr
   
   hr = AVIMakeCompressedStream(@psCompressed, ps, @opts, 0&)
   If hr <> 0 Then
      Return 0 
   End If
   
   'set the format of the compressed stream
   hr = AVIStreamSetFormat(psCompressed, 0, @bi, SizeOf(BITMAPINFOHEADER))   
   If hr <> 0 Then
      Return 0 
   End If
   
   Return psCompressed
      
End Function

Function WriteStreamData (ps As PAVISTREAM, framenum As Integer, pData As Byte Ptr, dwlen As Integer, KeyFrame As Integer) As Integer 
Dim As Integer    kf = IIf(KeyFrame=0,0,AVIIF_KEYFRAME)
    
   Return AVIStreamWrite(ps, framenum, 1, pData, dwlen, kf, NULL, NULL) 
      
End Function

Function CloseAVIStream(ps As PAVISTREAM) As Integer 

   'Close the stream. 
   AVIStreamRelease(ps) 
   Return 1
   
End Function

Function CloseAVI(pf As PAVIFILE) As Integer 
      
   AVIFileRelease(pf)    
   AVIFileExit()   
   Return 1
   
End Function

Function GetCompressionOptions(ps As PAVISTREAM) As AVICOMPRESSOPTIONS Ptr 
Dim As AVICOMPRESSOPTIONS Ptr    opts
Dim As HRESULT                   hr

   opts = New AVICOMPRESSOPTIONS

   'get the compression options from the user
   hr = AVISaveOptions(0, _
                       ICMF_CHOOSE_KEYFRAME Or ICMF_CHOOSE_DATARATE, _
                       1, _
                       @ps, _
                       @Opts)

   If hr = 0 Then
      Return 0 
   End If
   
   Return opts
      
End Function 
