/'
   Screen2AVI Object
   by Vincent DeCampo, (c)2009

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
'/

#Define __MAKELIB__ 

#Include Once "engine.bas"   
#Include Once "screen2avi.bi"

Constructor _Screen2AVI(filename As String, framerate As Integer)
Dim As ZString * 255    avifilename = filename

   ScreenInfo this.dx,this.dy,this.bpp,,this.pitch
   this.fps     = framerate
   this.fcount  = 0
   this.imgsize = this.pitch * this.dy

   With this.StrHdr_vid
      .fccType = streamtypeVIDEO
      .fccHandler = 0
      .dwFlags = 0
      .wPriority = 0
      .dwInitialFrames = 0
      .dwScale = 1 
      .dwRate = this.fps
      .dwLength = 0
      .dwSuggestedBufferSize = this.pitch*this.dy
      .dwQuality = -1
      .dwSampleSize = 0
   End With
       
   With this.bi
      .biBitCount = bpp
      .biClrImportant = 0
      .biClrUsed = 0
      .biCompression = BI_RGB
      .biWidth = this.dx
      .biHeight = this.dy
      .biPlanes = 1
      .biSize = SizeOf(BITMAPINFOHEADER)
      .biSizeImage = this.pitch*this.dy
      .biXPelsPerMeter = 0
      .biYPelsPerMeter = 0
   End With

'----------------------------------------

   /'
      CreateNewAVI
      ...
   '/
   this.pf = CreateNewAVI(@avifilename)
   If this.pf=0 Then Exit Constructor
      
   /'
      CreateVideoStream
      ...
   '/
   this.ps_vid = CreateVideoStream(this.pf,this.strhdr_vid,this.bi)
   
End Constructor

Destructor _Screen2AVI()

End Destructor

Function _Screen2AVI.AVIStart() As Integer

   If this.opts = 0 Then
      this.opts = GetCompressionOptions(this.ps_vid)
      If this.opts =0 Then Return 0
   End If
                   
   this.ps_vid_comp = CreateCompressedVideoStream(this.ps_vid,*this.opts,this.bi)
  
   Return 1

End Function

Function _Screen2AVI.LoadCompressionFile(filename As String) As Integer
   
   this.opts = LoadCompressionOptions(filename)
   If this.opts Then
      this.options_from_file = 1
      Return 1
   EndIf
   
   Return 0
   
End Function           

Function _Screen2AVI.SaveCompressionFile(filename As String) As Integer
   
   Return SaveCompressionOptions(filename,this.opts)
   
End Function           

Function _Screen2AVI.GetCompressionSettings() As Integer

   If this.opts Then
      Delete this.opts
   EndIf
   
   this.opts = GetCompressionOptions(this.ps_vid)

   If this.opts Then
      this.options_from_file = 0
      Return 1
   EndIf
   
   Return 0

End Function

Function _Screen2AVI.AddFrame() As Integer
Dim As UByte Ptr pData,pFlip
Dim As Integer kf = IIf(this.fcount Mod this.keyframe_every=0,1,0)
Dim As Integer scanline 
          
   pData = ScreenPtr
   If pData = 0 Then Return 0
   
   pData += this.imgsize - this.pitch 
   
   pFlip = Allocate(this.imgSize)
   If pFlip = 0 Then Return 0
      
   For scanline As Integer = 0 To this.dy-1
      memcpy pFlip+(scanline*this.pitch),pData-(scanline*this.pitch),this.pitch
   Next
   
   WriteStreamData (this.ps_vid_comp,this.fcount,pFlip,this.imgSize,kf)

   this.fcount += 1
      
   Return this.fcount
   
End Function            
         
Function _Screen2AVI.AVIStop() As Integer
     
   If this.ps_vid      Then CloseAVIStream(this.ps_vid)
   If this.ps_vid_comp Then CloseAVIStream(this.ps_vid_comp)
   If this.pf          Then CloseAVI(this.pf)

   If this.options_from_file Then     
      If this.opts Then
         If this.opts->lpFormat Then DeAllocate this.opts->lpFormat
         If this.opts->lpParms Then  DeAllocate this.opts->lpParms
         If this.opts Then Delete this.opts       
      End If
   Else
      If this.opts Then
         AVISaveOptionsFree(1, @this.opts)
      EndIf 
   End If
   
   Return 1
   
End Function   
   